#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "lista.h"

lista *crear()
{
	lista *nuevo;
	
	nuevo = (lista *)malloc(sizeof(lista));
	nuevo->primero = NULL;
	nuevo->anterior = NULL;
	return nuevo;
}

void anadir(lista *l, int e)
{
	nodo *nuevo;

	if (l->anterior == NULL)
	{
		printf("ERROR: la lista no esta inicializada (al aadir)\n");
		return;
	}

	nuevo = (nodo *)malloc(sizeof(nodo));

	-- COMPLETAR
}

void eliminar(lista *l)
{
	nodo *actual;
	
	if (l->anterior == NULL)
	{
		printf("ERROR: la lista no esta inicializada (al eliminar)\n");
		return;
	}

	if (l->anterior->sig == NULL)
	{
		printf("ERROR: fin de lista (al eliminar)\n");
		return;
	}

	
	actual = l->anterior->sig;
	-- COMPLETAR
	free(actual);
	
	return;
}

void principio(lista *l)
{
	if (l->anterior == NULL)
		l->anterior = (nodo *)malloc(sizeof(nodo));
	
	-- COMPLETAR
}

void avanzar(lista *l)
{

	if (l->anterior == NULL)
	{
		printf("ERROR: la lista no esta inicializada (al avanzar)\n");
		return;
	}

	if (l->anterior->sig == NULL)
	{
		printf("ERROR: fin de lista (al avanzar)\n");
		return;
	}

	-- COMPLETAR
}

int consultar(lista *l)
{
	-- COMPLETAR
}


int vacia(lista *l)
{
	-- COMPLETAR
}


int final(lista *l)
{
	-- COMPLETAR
}


int main()
{
	lista *l;
	
	l = crear();

	anadir(l,0);
	
	principio(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	
	anadir(l,1);
	
	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);
	
	anadir(l,2);
	
	anadir(l,3);
	
	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	avanzar(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	avanzar(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	avanzar(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	printf("Volvemos al principio de la lista\n");

	principio(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	eliminar(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	eliminar(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	avanzar(l);

	printf("El elemento actual de la lista es %d\n", consultar(l));
	printf("El primer elemento de la lista es %d\n", l->primero->elemento);

	return 0;
}
